signature EXP = 
sig
        datatype exp = N of int
                     | V of string
                     | PLUS of exp*exp
                     | MINUS of exp*exp
                     | MULT of exp*exp
                     | DIV of exp*exp
                     | MOD of exp*exp
                     ;
        val calculate : (string -> int) -> exp -> int
end;

structure Exp : EXP =
struct
        datatype exp = N of int
                     | V of string
                     | PLUS of exp*exp
                     | MINUS of exp*exp
                     | MULT of exp*exp
                     | DIV of exp*exp
                     | MOD of exp*exp
                     ;

        fun calculate gamma (N n) = n
           |calculate gamma (V v) = gamma(v)
           |calculate gamma (PLUS(e1,e2)) = (calculate gamma e1) + (calculate gamma e2)
           |calculate gamma (MINUS(e1,e2)) = (calculate gamma e1) - (calculate gamma e2)
           |calculate gamma (MULT(e1,e2)) = (calculate gamma e1) * (calculate gamma e2)
           |calculate gamma (DIV(e1,e2)) = (calculate gamma e1) div (calculate gamma e2)
           |calculate gamma (MOD(e1,e2)) = (calculate gamma e1) mod (calculate gamma e2)
end
