structure Parser:
sig 
	val parse : string -> DataTypes.procedure
end =
struct
exception BuildAstError;

fun parse (fileName) = 
    let val inStream =  TextIO.openIn fileName;
        val grab : int -> string = fn n => if TextIO.endOfStream inStream then ""
			                 else TextIO.inputN (inStream,n);

        val printError : string * int * int -> unit = fn 
            (msg,line,col) => print (fileName^"["^Int.toString line^":"^Int.toString col^"] "^msg^"\n");

        val (tree,rem) = BuildAstParser.parse(15,(BuildAstParser.makeLexer grab fileName),printError,fileName)
            handle BuildAstParser.ParseError => raise BuildAstError;
        (* Close the source program file *)
        val _ = TextIO.closeIn inStream;
    in tree
    end
end;
